;
; channel15_2.asm - channel 15 command execution
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

channel15_cont	.proc

		ldx #commandslo-commands
htnuo		cmp commands-1,x
		bne njooocmd
		lda commandshi-1,x
		pha
		lda commandslo-1,x
		pha
		lda path_exp+1
		rts

njooocmd	dex
		bne htnuo

cmdnotimp	.proc
		sec
		gcs LWOP_reporterror_31_xit;Unknown command
		.pend
                
cmdsynterr	.proc
		sec
		gcs LWOP_reporterror_30_xit;Command syntax
		.pend

;-------------------------------
;U
;
cmd_user	.proc
		cmp #"0"
		beq usercmd0
		and #15
		cmp #10
		beq usercmdreset
		cmp #9
		bne cmdnotimp
;-------------------------------
;UI/U9
;
usercmd9	.proc
                sec
		gcs LWOP_reporterror_73_xit
		.pend
;-------------------------------
;UJ/U:
;
usercmdreset	.proc
;       	lda current_drive_exp	;no detection, cannot reset only _one_ of the devices
;		jsr OP_hdinit
		lda current_drive_exp
		jmp OP_XIT_hdinit_2
		.pend
;-------------------------------
;U0>
;
usercmd0	.proc
		lda path_exp+2
		cmp #">"
		bne cmdsynterr
		lda path_exp+3
in		cmp #31			;"U0>"+CHR$(<drivenumber>)
		bcs usercmdnnumber
		#ldx_l_ current_drive_exp
		sta current_drivenumbers_exp,x
                gcc usercmdnnumber.ok
		.pend
;-------------------------------
;U0>P
;
usercmdnnumber	.proc
		cmp #"p"		;"U0>P"+CHR$(<powermode>)
		bne usercmdnp
		lda path_exp+4
		lsr
		ldx #idle_imediate1_d
		lda #idle_imediate2_d
		bcs fgh
		ldx #standby_now1_d
		lda #standby_now2_d
fgh		jsr try2
ok		jmp LWOP_reporterror_ok
		.pend
;-------------------------------
;U0>P
;
usercmdnp	.proc
		cmp #"P"		;"u0>P"
		bne usercmdnpp
		jsr select_drive
		ldx #check_power_mode1_d
		lda #check_power_mode2_d
                jsr try2
		lda nsector_g
                #lda_low_reg
                #jmps usercmdnl.return1
		.pend
                
try2            .proc
		pha
                #phx_a
                jsr select_drive
                pla
		jsr ata_command
                pla
		bcc ok
		jsr ata_command
ok		jmp LWOP_reporterror_xit
		.pend
;-------------------------------
;U0>E
;
usercmdnpp	.proc
		cmp #"e"		;"U0>E"+CHR$(<mode>)
		bne usercmdne
                lda #ATAPI_CMD_START_STOP
                jsr cucc
                eor #3
                gne usercmdne.in
                
cucc            pha
		jsr XIT_init_drive2
                pla
		jsr OP_atapi_packet
		lda path_exp+4
		and #1
		rts
;-------------------------------
;U0>L
;
usercmdne	.proc
		cmp #"l"		;"U0>L"+CHR$(<mode>)
		bne usercmdnl
		lda #ATAPI_CMD_LOCK_UNLOCK
                jsr usercmdnpp.cucc
in		#pw 4

doatapicommand	.proc                
		jsr OP_atapi_command
		jsr LWOP_reporterror_xit
		jmp LWOP_reporterror_ok
                .pend

playstop       	.proc
		lda #ATAPI_CMD_STOP_PLAY_SCAN
		.byte SKIP2
playpauseresume	.proc		;"U0>CP"+CHR$(PAUSE/RESUME)
                lda #ATAPI_PAUSE_RESUME
                jsr OP_atapi_packet
                lda path_exp+5
                and #1
                #pw 8
		gpl doatapicommand
                .pend
                
playaudiomsf   	.proc		;"U0>CA"+CHR$(FEND)+CHR$(SEND)+CHR$(MEND)+CHR$(FST)+CHR$(SST)+CHR$(MST)
		lda #ATAPI_PLAY_AUDIO_MSF
		jsr OP_atapi_packet
                ldx #5
lu      	lda path_exp+5,x
                sta packet_buff_exp+3,x
                dex
                bpl lu
                gmi doatapicommand
                .pend
;-------------------------------
;U0>A
;
usercmdnl	.proc
		cmp #"c"
		bne kq
                jsr XIT_init_drive2
                lda path_exp+4
                cmp #"p"
                beq playpauseresume
                cmp #"s"
                beq playstop
                cmp #"a"
                beq playaudiomsf
                cmp #"v"
                beq volume
                cmp #"V"
                beq volume2
                cmp #"m"
                beq media
kq              gne cmdnotimp

volume2		lda #$0e
		jsr mode_sense2

                lda #8
                jsr channel_ret
                
                #ldy_l_a ram_exp_buffer0_exp+$1
lp2             #lda_l_y_ ram_exp_buffer0_exp-6
                sta drive_status_exp,x
                iny
                inx
                txa
                and #7
                bne lp2
                rts

media		lda #$0e
		jsr mode_sense2
                lda ram_exp_buffer0_exp+2
                
return1         pha
                lda #1
                jsr channel_ret
                pla
                sta drive_status_exp,x
                rts
                
volume      	lda #$0e
		jsr mode_sense2
                ldx #0
nu              lda ram_exp_buffer0_exp,x
                sta ram_exp_buffer0_exp+$100,x
                inx
                bpl nu
                lda #$4e
		jsr mode_sense2
                
                ldy #7
                #ldx_l_a ram_exp_buffer0_exp+$101
lp              lda ram_exp_buffer0_exp+1,x
                beq nc
                #and_l_y_ path_exp+5
                sta ram_exp_buffer0_exp+$101,x
nc		dex
		dey
                bpl lp

fh      	jsr mode_select_st
                jsr LWOP_reporterror_write_xit
                jsr mode_select_en
	        jsr LWOP_reporterror_write_xit
v		jmp LWOP_reporterror_ok

mode_select_st 	lda #ATAPI_MODE_SELECT
                jsr OP_atapi_packet
                #pc 1,$10
                lda ram_exp_buffer0_exp+$101
                clc
                adc #2
                #pw 8
                jmp OP_atapi_dataout_command

mode_select_en  lda ram_exp_buffer0_exp+$101
                lsr
                tay
                ldx #0
lue             lda ram_exp_buffer0_exp+$100,x
                sta low_reg
                inx
                lda ram_exp_buffer0_exp+$100,x
                sta hig_reg
                sta data_g
                
                #phx_a
                #phy_a
                jsr wait_busy           ;wait until writing finished
                #ply_a
                #plx_a
                bcs nj

                inx
                dey
                bpl lue
                jsr wait_busy           ;wait until writing finished
		bcs nj
                jsr ata_pi_nomore_data
nj            	rts

mode_sense2   	jsr mode_sense
                jmp LWOP_reporterror_xit
                
mode_sense	pha
		lda #ATAPI_MODE_SENSE
		jsr OP_atapi_packet
                pla
                #pw 2
                #pc 8,$80
                jsr OP_atapi_datain_command
                bcs nj
                ldx #0
np              lda data_g
		#lda_low_reg
                sta ram_exp_buffer0_exp,x
                inx
                lda hig_reg
                sta ram_exp_buffer0_exp,x
                inx
                bpl np
                gmi ata_pi_nomore_data
		.pend
;-------------------------------
;Idle off in 16 secs (for setfeatures)
;
cdrom_idleoff   .proc
		lda #$0d
		jsr usercmdnl.mode_sense
                bcs gon
                ldx #0
nup             lda ram_exp_buffer0_exp,x
                sta ram_exp_buffer0_exp+$100,x
                inx
                bpl nup

                lda #$4d
		jsr usercmdnl.mode_sense
                bcs gon

                lda ram_exp_buffer0_exp+$00b
                beq nce
                and #8
                sta ram_exp_buffer0_exp+$10b
nce
		jsr usercmdnl.mode_select_st
                bcs gon
                jsr usercmdnl.mode_select_en
gon             rts
		.pend
;-------------------------------
;G get partition
;
;"G-P"           Current partition
;"G-P"+CHR$(255) Current partition
;"G-P"+CHR$(k)   Other partition
;
;1st byte: 0 not created, 1 native, 2 1541, 3 1571, 4 1581, 5 1581 cpm, 6 Spool, 7 Foreign, 255 system
;2nd byte: info
;3rd byte: partition
;4-19th byte: Partition name
;20-28th byte: ???
;29-30th byte: size of partition

cmd_g		.proc
		jsr OP_short_path
                cmp #"-"
                bne nkqx
		jsr OP_short_path
                cmp #"p"
                bne nkqx
                jsr OP_short_path
                cmp #255
                bne *+4
                lda #0
                pha

		jsr XIT_init_drive	;-=> error

                pla
                jsr OP_check_partition_selection
                #lda0
                bcs tt
                iny
                lda #1
tt              pha

                lda #3+16+9+2
                jsr channel_ret
                pla			;Native partition
                sta drive_status_exp,x
                lda #$e0		;Disk in, formatted, CMD formatted, unknown size
                sta drive_status_exp+1,x
                tya
                sta drive_status_exp+2,x
                lda #32
                ldy #16+9
nk              sta drive_status_exp+3,x
                inx
                dey
                bne nk
                lda #255
                sta drive_status_exp+3,x
                sta drive_status_exp+4,x
		rts
		.pend

nkqx		jmp cmdnotimp
;-------------------------------
;S remove file
;
;"S-8" swap 8
;"S-9" swap 9
;"S-D" swap default
;
cmd_s		.proc
                jsr OP_short_path
                cmp #"9"
                beq nj2
                cmp #"d"
                beq nj3
                cmp #"8"
                bne nkqx		;not implemented

nj2		and #$0f
ej		#jmps usercmd0.in

nj3		#ldx_l_a current_drive_exp
                lda setup_drivenumbers_exp,x
                and #$0f
                clc
                adc #7
                gcc ej
                .pend
;-------------------------------
;Fake memory read and write
;
;fea0 "CMD HD" CMD HD
;fea0 "CMD RL" CMD RamLink
;fea0 "CMD RD" CMD RamDrive
;e5c6 "4"      1541
;e5c6 "7"      1571
;a6e9 "8"      1581
;fea0 "CMD FD" CMD FD
;
cmd_memory      .proc
		lda path_exp+2
                cmp #"w"
                beq cmd_skip
                cmp #"r"
                bne nkqx		;not implemented
                lda path_exp+5
                cmp #60
                bcc *+4
                lda #60
                sta pom1

                jsr channel_ret
                #ldy_l_a path_exp+3
                lda setup_atribut2_exp	;CMD emulation?
                asl

lul             tya
		and #31
                bcs *+4
                ora #16
                tay
		lda ou,y
                sta drive_status_exp,x
                inx
                iny
                dec pom1
                bpl lul
		rts

ou              .text "cmd hd emulated "	;Fake drive ROM
ou2             .text "ide64 cartridge "	;Fake drive ROM
		.pend

cmd_skip	.proc
		jmp LWOP_reporterror_ok
                .pend

channel_ret     .proc
		#ldx_l_ current_drive_exp
                sta status_size_exp,x
                #lda0
                sta status_pos_exp,x
                .if DRIVES=4
                bit errledoff_g
                .fi
		txa
		lsr
		ror			;*64
		ror
		tax
		rts
                .pend
;-------------------------------
;T Time
;
;T-RA
;T-RB
;T-RD
;T-WA
;T-WB
;T-WD
;
;SUN. 00/00/00 00:00:00 AM
;
cmd_t		.proc
                jsr OP_short_path
                cmp #"-"
                bne n
                jsr OP_short_path
                cmp #"r"
                bne n
                jsr OP_short_path
                cmp #"a"
                beq q
                cmp #"b"
                beq q
                cmp #"d"
n               bne cmdnotimp
q		pha
                
		jsr LWOP_read_clock

;00 -> 12 AM
;01 -> 01 AM
;..
;11 -> 11 AM
;12 -> 12 PM
;13 -> 01 PM
;..
;23 -> 11 PM
                lda hour_exp
                cmp #$12
                php
                tax
                bne *+4
                lda #$12
                cmp #$13
                bcc xq
                sei
                sed
                sbc #$12
xq              plp
		sta hour_exp
		#lda0
                sta pom1
                ror
                sta ampm_exp

		pla
                cmp #"d"
                bne nu

                ldy #6
rk
		#lda_l_y_x sec_exp
                jsr bcd2bin
		#sta_l_y_x sec_exp
                dey
                bpl rk
                tya
nu
		cmp #"b"

		lda #8
                bcs *+4
                lda #25
                php
                jsr channel_ret

                lda day_exp
                #sbc1c
                plp
                bcc asc
ry              jsr aaa
                ldy pom1
                inc pom1
                cpy #7
                lda fk,y
                tay
                #lda_l_y_ sec_exp
                bcc ry
		rts

fk              .byte year_exp-sec_exp
		.byte month_exp-sec_exp
		.byte date_exp-sec_exp
		.byte hour_exp-sec_exp
		.byte min_exp-sec_exp
		.byte sec_exp-sec_exp
                .byte ampm_exp-sec_exp
		
asc		asl
		asl
                tay
nuo             lda days,y
                iny
                jsr aaa
                txa
                and #3
                bne nuo
                tay
rp              lda dl,y
                jsr aaa
                lda fk2,y
                tay
                #lda_l_y_ sec_exp
                jsr appa
                inc pom1
                ldy pom1
                cpy #6
                bcc rp

                lda #$20
                jsr aaa
                lda ampm_exp
                asl
                lda #"a"
                bcc *+4
                lda #"p"
                jsr aaa
                lda #"m"
                gne aaa

appa            pha
		lsr
                lsr
                lsr
                lsr
                jsr aa
                pla
aa		and #$0f
                ora #$30
aaa		sta drive_status_exp,x
                inx
		rts
                
dl              .byte " // ::"
fk2		.byte month_exp-sec_exp
		.byte date_exp-sec_exp
                .byte year_exp-sec_exp
		.byte hour_exp-sec_exp
		.byte min_exp-sec_exp
		.byte sec_exp-sec_exp


days		.text "sun."
		.text "mon."
		.text "tues"
		.text "wed."
		.text "thur"
		.text "fri."
		.text "sat."
                .pend
;-------------------------------
;N format
;
;
cmd_n		.proc
                jsr OP_short_path
                cmp #"="
                bne nkq
                jsr OP_short_path
                
                ldy #0
                clc
ne2             ldx #0
ne              lda formats,y
                bmi ni
                eor path_exp,x
                beq *+3
                sec
                iny
                inx
                gne ne

ni		bcs ee
		and #$7f
		eor path_exp,x
                beq joo
ee              iny
		iny
                iny
                iny
                cpy #formatsend-formats
                bcc ne2
nkq		jmp cmdnotimp

joo		#phy_a
		jsr XIT_init_drive2

		lda #ATAPI_FORMAT_UNIT
		jsr OP_atapi_packet
		#pc 1,%00010111
		jsr OP_atapi_dataout_command

		#lda0
		jsr OP_atapi_packet

             	#pc 1,%10100010
		#pc 3,8
		#pc 10,>512
                
                #ply_a                
                ldx #2
lu              iny
		lda formats,y
                sta packet_buff_exp+4,x
                dex
                bpl lu

		ldx #11
lp		lda packet_buff_exp,x	;Send the command to the device.
		sta low_reg
		dex
		lda packet_buff_exp,x
		sta hig_reg
		sta data_g
		dex
		bpl lp
                jsr ata_pi_nomore_data
		bcs nj
		jsr wait_busy		;wait until writing finished
nj              jsr LWOP_reporterror_write_xit
		jsr invalidate_drive		
		jmp LWOP_reporterror_ok
                
formats         .text "720K"
                .byte $00,$05,$a0	;80/2/9 75Kbps 720rpm
                .text "1.2M"
                .byte $00,$09,$60	;80/2/15 125Kbps 720rpm
                .text "1.44M"
                .byte $00,$0b,$40	;80/2/18 150Kbps 720rpm
                .text "120M"
                .byte $03,$c3,$00	;963/8/32 533Kbps 720rpm
;                .text "100M"
;                .byte $00,$02,$ff,$e0	;96/64/32 4096Kbps 2941rpm (does not work)
;                .text "250M"
;                .byte $00,$xx,$xx,$xx	;239/64/32 (does not work)
formatsend
                .pend

commands	.text "gusmvnt"
commandslo    	.byte <(cmd_g-1)
		.byte <(cmd_user-1)
		.byte <(cmd_s-1)
		.byte <(cmd_memory-1)
		.byte <(cmd_skip-1)
		.byte <(cmd_n-1)
		.byte <(cmd_t-1)
commandshi     	.byte >(cmd_g-1)
		.byte >(cmd_user-1)
		.byte >(cmd_s-1)
		.byte >(cmd_memory-1)
		.byte >(cmd_skip-1)
		.byte >(cmd_n-1)
		.byte >(cmd_t-1)
