;
; errors.asm - DOS error channel messages
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
messages	.text 0+$80,"ok"
		.text 1+$80,"files scratched"
		.text 2+$80,"partition selected"
		.text 20+$80,21+$80,22+$80,23+$80,"read",0
		.text 25+$80,28+$80,"write",0
		.text 26+$80,"write protect on"
		.text 27+$80,"access denied"
		.text 29+$80,"disk changed"
		.text 30+$80,32+$80,33+$80,34+$80,"syntax",0
		.text 31+$80,"unknown command"
		.text 39+$80,"path not found"
;		.text 50+$80,"seek beyond end"
;                .text 51+$80,"overflow in record"
;                .text 52+$80,"file too large"
;                .text 60+$80,"write file open"
;                .text 61+$80,"file not open"
		.text 62+$80,"file not found"
		.text 63+$80,"file exists"
		.text 64+$80,"file type mismatch"
		.text 66+$80,67+$80,"illegal request"
		.text 70+$80,"no channel"
		.text 71+$80,"dir",0
                .text 72+$80,"partition full"
		.text 73+$80,"ide dos "	;System message
		#version
		.byte 32
		.TEXT 74+$80,"drive not ready"
		.TEXT 75+$80,"format",0
                .TEXT 76+$80,"hardware",0
		.TEXT 77+$80,"selected partition illegal"
		.TEXT $80," error"
		.text 10+$80,"ide64"	;Hard disk, CompactFlash
		.text 11+$80,"cdrom"	;CDROM, DVD
		.text 12+$80,"fdd64"	;ZipDrive, LS-120
		.byte $80

LWOP_setdosvmsg	.proc
		jsr OP_get_current_drive_type
		asl
		php
		asl
		lda #5
		rol
		plp
		adc #0
		pha
		lda #73
		jsr LWOP_disk_status.in
                .if DRIVES=4
                bit errledoff_g
                .fi
		pla
		#jmps LWOP_disk_status_more
;-----------------------------------
;Set disk status from A       POM1,POM2 used!!!
;-----------------------------------
LWOP_disk_status .proc
		cmp #$80
		and #$7f
                php
                jsr do
                plp
                #lda0
                sta pom1
                sbc #0
ou		ldy pom1
	      	inc pom1
		pha
		and next_sector,y
		jsr append_status_dec
                lda pom1
                cmp #4
                pla
                bcc ou
		txa
		#ldx_l_ current_drive_exp
                and #63
		sta status_size_exp,x
		rts

do		cmp #73
		beq LWOP_setdosvmsg
                .if DRIVES=4
                cmp #20
                bcc in
                bit errledon_g
                .fi
in		pha
		#ldx_l_a current_drive_exp
		#lda0
		sta pom1
		sta status_pos_exp,x
		txa
		lsr
		ror			;*64
		ror
		tax
		pla
		pha
		jsr append_status_dec2
		lda #","
		jsr append_status
		lda #$20
		jsr append_status
		ldy #<messages
		lda #>messages
		sta pom2
		pla
LWOP_disk_status_more .proc
		ora #$80
snm		cmp (pom1),y		;!!!!!!!!! not cmp_zp_y!
		beq snmbe
		iny
		bne snm
		inc pom2
		bne snm

dsd2		lda (pom1),y		;!!!!!!!!! not lda_zp_y!
		beq LWOP_disk_status_more;append " ERROR"
		bpl msg_betu		;normal text
		txa
		and #63
		cmp #5
		bcs snm2		;end of text reached
		bcc snmbe
msg_betu	jsr append_status
snmbe		iny
		bne dsd2
		inc pom2
		bne dsd2
snm2		rts
		.pend

append_status_dec .proc
		pha
		lda #","
		jsr append_status
		pla
		ldy #47
		sec
		iny
		sbc #100
		bcs *-3
		adc #100
		pha
		tya
		jsr append_status
		pla
append_status_dec2 .proc
		ldy #47
		sec
		iny
		sbc #10
		bcs *-3
		adc #58
		pha
		tya
		jsr append_status
		pla

append_status	.proc
		sta drive_status_exp,x
		inx
		rts
		.pend
